/*
 * Copyright (c) 2007 Michal Kebrt
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * - Redistributions of source code must retain the above copyright
 *   notice, this list of conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright
 *   notice, this list of conditions and the following disclaimer in the
 *   documentation and/or other materials provided with the distribution.
 * - The name of the author may not be used to endorse or promote products
 *   derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/** @addtogroup arm32
 * @{
 */
/** @file
 */


#include <arch.h>
#include <arch/boot.h>
#include <config.h>
#include <arch/console.h>
#include <ddi/device.h>

#include "aux_print/printf.h"

bootinfo_t bootinfo;

void arch_pre_main(void)
{
	aux_printf("arch_pre_main\n");
	int i;

	init.cnt = bootinfo.cnt;

	for (i = 0; i < bootinfo.cnt; ++i) {
		init.tasks[i].addr = bootinfo.tasks[i].addr;
		init.tasks[i].size = bootinfo.tasks[i].size;
//		aux_printf("%L, %d\n", bootinfo.tasks[i].addr, bootinfo.tasks[i].size);
	}

}

void arch_pre_mm_init(void)
{
	aux_printf("arch_pre_mm_init\n");

	console_init(device_assign_devno());

}

void arch_post_mm_init(void)
{
	aux_printf("arch_post_mm_init\n");
	/* TODO */
}

void arch_post_cpu_init(void)
{
	/* TODO */
}

void arch_pre_smp_init(void)
{
	/* TODO */
}

void arch_post_smp_init(void)
{
	/* TODO */
}

/** Perform arm32 specific tasks needed before the new task is run. */
void before_task_runs_arch(void)
{
	/* TODO */
}

/** Perform arm32 specific tasks needed before the new thread is scheduled. */
void before_thread_runs_arch(void)
{
	/* TODO */
}

void after_thread_ran_arch(void)
{
	/* TODO */
}

/** @}
 */
